IndividualHudFruit = {};
IndividualHudFruit.metadata = {
	interface = " FS19 ...",
	title = " IndividualHudFruit",
	notes = " setzt neue Huds für Früchte",
	author = " (by HappyLooser)",
	version = " v0.6 Final",	
	datum = " 02.01.2015",
	update = " 17.02.2019",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

local pathFiles;
local path = getUserProfileAppPath();

function IndividualHudFruit:loadMap(name)
	g_currentMission.individualHudFruit = IndividualHudFruit;
	print("---loading".. tostring(IndividualHudFruit.metadata.title).. tostring(IndividualHudFruit.metadata.version).. tostring(IndividualHudFruit.metadata.author).. "---")
	local pathSavegame = path.. "/IndividualHudFiles/savegame".. g_currentMission.missionInfo.savegameIndex.. "/";	
	if not fileExists(path.. "IndividualHudFiles/") then createFolder(path.. "IndividualHudFiles/");end;
	local isServer = FolderExists(pathSavegame);	
	if isServer then 
		print("---IndividualHudFruit...not load FillType/FruitType Files for Server---")
		return;
	end;
	local fillTypeNames = "Found fillType names: ";
	local fillTypeNamesHud = "Found fillType Hud names: ";
	local fruitTypeNames = "Found fruitType names: ";
	local fruitTypeNamesHud = "Found fruitType Hud names: ";
	local replaceFillTypes = 0;
	local replaceFillTypesHud = 0;
	local replaceFruitTypes = 0;
	local replaceFruitTypesHud = 0;
	if IndividualHudFruit.indexToFillType == nil then IndividualHudFruit.indexToFillType = {};IndividualHudFruit.indexToFillTypeName = {};end;
	if IndividualHudFruit.displayFillTypes == nil then IndividualHudFruit.displayFillTypes = {};end;
	if pathFiles ~= nil then
		for i=1, #g_currentMission.fillTypeManager.fillTypes do
			local desc = g_currentMission.fillTypeManager.fillTypes[i];			
			local name = desc.name;			
			fillTypeNames = fillTypeNames.. name.. ",";			
			local individualHudFile = getHudFiles(name, nil, false);
			local individualHudFileSmall = getHudFiles(name, nil, true);			
			if individualHudFile ~= nil then
				desc.hudOverlayFilename = individualHudFile;
				replaceFillTypes = replaceFillTypes+1;
				if individualHudFileSmall ~= nil then 
					desc.hudOverlayFilenameSmall = individualHudFileSmall;					
				else					
					desc.hudOverlayFilenameSmall = individualHudFile;
				end;				
			end;
		end;
		for i=1, #g_currentMission.fruitTypeManager.fruitTypes do
			local desc = g_currentMission.fruitTypeManager.fruitTypes[i];			
			local name = desc.name;			
			fruitTypeNames = fruitTypeNames.. name.. ",";			
			local individualHudFile = getHudFiles(name, nil, false);
			local individualHudFileSmall = getHudFiles(name, nil, true);			
			if individualHudFile ~= nil then
				desc.hudOverlayFilename = individualHudFile;
				replaceFruitTypes = replaceFruitTypes+1;
				if individualHudFileSmall ~= nil then 
					desc.hudOverlayFilenameSmall = individualHudFileSmall;					
				else					
					desc.hudOverlayFilenameSmall = individualHudFile;
				end;				
			end;
		end;		
		--testing, next update		
		for i=1, #g_currentMission.hud.fillTypeManager.fillTypes do
			local desc = g_currentMission.hud.fillTypeManager.fillTypes[i];			
			local name = desc.name;			
			fillTypeNamesHud = fillTypeNamesHud.. name.. ",";			
			local individualHudFile = getHudFiles(nil, name, false);
			local individualHudFileSmall = getHudFiles(nil, name, true);			
			if individualHudFile == nil then individualHudFile = getHudFiles(name, nil, false);end;
			if individualHudFileSmall == nil then individualHudFileSmall = getHudFiles(name, nil, true);end;
			if individualHudFile ~= nil then
				desc.hudOverlayFilename = individualHudFile;
				replaceFillTypesHud = replaceFillTypesHud+1;
				if individualHudFileSmall ~= nil then 
					desc.hudOverlayFilenameSmall = individualHudFileSmall;					
				else					
					desc.hudOverlayFilenameSmall = individualHudFile;
				end;				
			end;
		end;
		for i=1, #g_currentMission.hud.fruitTypeManager.fruitTypes do
			local desc = g_currentMission.hud.fruitTypeManager.fruitTypes[i];			
			local name = desc.name;			
			fruitTypeNamesHud = fruitTypeNamesHud.. name.. ",";			
			local individualHudFile = getHudFiles(nil, name, false);
			local individualHudFileSmall = getHudFiles(nil, name, true);			
			if individualHudFile == nil then individualHudFile = getHudFiles(name, nil, false);end;
			if individualHudFileSmall == nil then individualHudFileSmall = getHudFiles(name, nil, true);end;
			if individualHudFile ~= nil then
				desc.hudOverlayFilename = individualHudFile;
				replaceFruitTypesHud = replaceFruitTypesHud+1;
				if individualHudFileSmall ~= nil then 
					desc.hudOverlayFilenameSmall = individualHudFileSmall;					
				else					
					desc.hudOverlayFilenameSmall = individualHudFile;
				end;				
			end;
		end;		
		--testing,next update
		function refreshFillTypeIcons()
			local result = IndividualHudFruit.displayFillTypes[1];
			if result == nil then return;end;
			for _, v in pairs(result.fillTypeFrames) do
				v:delete()
			end			
			local posX, posY = result:getPosition()
			result:createFillTypeFrames(g_currentMission.fillTypeManager, result.hudAtlasPath, posX, posY)
		end;
		refreshFillTypeIcons();
		if replaceFillTypes > 0 then
			print("---IndividualHudFruit...replace ".. tostring(replaceFillTypes) .." FillTypes---")
		else
			print("!!! IndividualHudFruit...not found FillType Files !!!")
			print("!!! copy fillType files ---> .../IndividualHudFiles/_wheat.dds(_wheat_sml.dds) etc. etc. !!!")
		end;
		if replaceFruitTypes > 0 then
			print("---IndividualHudFruit...replace ".. tostring(replaceFruitTypes) .." FruitTypes---")
		else
			print("!!! IndividualHudFruit...not found FruitType Files !!!")
			print("!!! copy fruitType files ---> .../IndividualHudFiles/_seeds.dds(_seeds_sml.dds) etc. etc. !!!")
		end;
		if replaceFillTypesHud > 0 then
			print("---IndividualHudFruit...replace ".. tostring(replaceFillTypesHud) .." Hud FillTypes---")
		else
			print("!!! IndividualHudFruit...not found Hud FillType Files !!!")
			print("!!! copy hud fillType files ---> .../IndividualHudFiles/hud_wheat.dds(hud_wheat_sml.dds) etc. etc. !!!")
		end;
		if replaceFruitTypesHud > 0 then
			print("---IndividualHudFruit...replace ".. tostring(replaceFruitTypes) .." Hud FruitTypes---")
		else
			print("!!! IndividualHudFruit...not found Hud FruitType Files !!!")
			print("!!! copy hud fruitType files ---> .../IndividualHudFiles/_seeds.dds(_seeds_sml.dds) etc. etc. !!!")
		end;
		print("---IndividualHudFruit...search map names---")
		print(fillTypeNames)
		print("------")
		print(fillTypeNamesHud)
		print("------")
		print(fruitTypeNames)
		print("------")
		print(fruitTypeNamesHud)
		print("------")
	else
		print("!!! IndividualHudFruit...not found FillTypes/FruitTypes Files !!!")
		print("!!! copy fillTypes/fruitTypes files ---> .../IndividualHudFiles/_wheat.dds(_wheat_sml.dds) etc. etc. !!!")
	end;	
end;

function IndividualHudFruit:deleteMap()	
end;

function IndividualHudFruit:mouseEvent(posX, posY, isDown, isUp, button)
end;

function IndividualHudFruit:keyEvent(unicode, sym, modifier, isDown)	
end;

function IndividualHudFruit:update(dt)
end;

function IndividualHudFruit:draw(dt)
end;
addModEventListener(IndividualHudFruit);

function FolderExists(strFolderName)	
	if g_server ~= nil and g_client == nil then
		isClient = true;
		return true;
	end;
	if fileExists(strFolderName.. "*.dds") then
		pathFiles = strFolderName;
	else		
		local pathHud = path.."/IndividualHudFiles/";
		if fileExists(pathHud.. "*.dds") then
			pathFiles = pathHud;
		end;
	end;	
end;

function getHudFiles(fruitName, fruitNameHud, small)
	if fruitName ~= nil then
		if not small then
			if fileExists(Utils.getFilename("_".. string.lower(fruitName).. '.dds', pathFiles)) then
				return Utils.getFilename("_".. string.lower(fruitName).. '.dds', pathFiles)	
			end;
		else
			if fileExists(Utils.getFilename("_".. string.lower(fruitName).. '_sml.dds', pathFiles)) then
				return Utils.getFilename("_".. string.lower(fruitName).. '_sml.dds', pathFiles)	
			end;
		end;
	end;
	if fruitNameHud ~= nil then
		if not small then
			if fileExists(Utils.getFilename("hud_".. string.lower(fruitNameHud).. '.dds', pathFiles)) then
				return Utils.getFilename("hud_".. string.lower(fruitNameHud).. '.dds', pathFiles)	
			end;
		else
			if fileExists(Utils.getFilename("hud_".. string.lower(fruitNameHud).. '_sml.dds', pathFiles)) then
				return Utils.getFilename("hud_".. string.lower(fruitNameHud).. '_sml.dds', pathFiles)	
			end;
		end;
	end;
end;

local oldFillLevelDisplay = FillLevelsDisplay.new
FillLevelsDisplay.new = function(...)
	local isOkay, result = pcall(oldFillLevelDisplay, ...);
	if isOkay and result ~= nil then		
		if IndividualHudFruit.displayFillTypes == nil then IndividualHudFruit.displayFillTypes = {};end;
		IndividualHudFruit.displayFillTypes[#IndividualHudFruit.displayFillTypes+1] = result;
		return result;
	end;
end;
